-- Functions Specific to the Options Frame


-- ColorPicker Code origonally borrowed from SimpleTranqShot
-- Banner Color Picker
function EnhancedAssist_ColorPicker_Banner()
	ColorPickerFrame.func = EnhancedAssist_ColorPicker_BannerFunc;
	ColorPickerFrame.hasOpacity = nil;
	ColorPickerFrame.opacityFunc = nil;
	ColorPickerFrame.opacity = nil;
	ColorPickerFrame:SetColorRGB( EnhancedAssistOptions.Colors.Banner.r, EnhancedAssistOptions.Colors.Banner.g, EnhancedAssistOptions.Colors.Banner.b );
	ColorPickerFrame.previousValues = { r = EnhancedAssistOptions.Colors.Banner.r, g = EnhancedAssistOptions.Colors.Banner.g, b = EnhancedAssistOptions.Colors.Banner.b, opacity = 1.0 };
	ColorPickerFrame.cancelFunc = EnhancedAssist_ColorPicker_BannerCancelFunc;
	ShowUIPanel(ColorPickerFrame);
end
function EnhancedAssist_ColorPicker_BannerFunc()
	local newR, newG, newB = ColorPickerFrame:GetColorRGB();
	EAOFSO_ColorPicker_BannerNormalTexture:SetVertexColor(newR, newG, newB);
	EnhancedAssistOptions.Colors.Banner = { r = newR, g = newG, b = newB };
end
function EnhancedAssist_ColorPicker_BannerCancelFunc(previousValues)
	if ( previousValues.r ) then
		EAOFSO_ColorPicker_BannerNormalTexture:SetVertexColor(previousValues.r, previousValues.g, previousValues.b);
		EnhancedAssistOptions.Colors.Banner = { r = previousValues.r, g = previousValues.g, b = previousValues.b };
	end
end

function EnhancedAssistOptionsFrame_OnShow()
	EAOFSO_ColorPicker_BannerNormalTexture:SetVertexColor( EnhancedAssistOptions.Colors.Banner.r, EnhancedAssistOptions.Colors.Banner.g, EnhancedAssistOptions.Colors.Banner.b );
	if (EAOFSO_AssistWindow:GetChecked()) then
		EAOFSO_HideOutOfGroup:Enable();
		EAOFSO_HideOutOfGroupLabel:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	else
		EAOFSO_HideOutOfGroup:Disable();
		EAOFSO_HideOutOfGroupLabel:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)
	end
	-- When the user mode is set to healer update the labels of the MA and SA to the MH and MH labels
	if (EnhancedAssistOptions.UserMode == 3) then
		EAOF_MABoxLabel:SetText(EAOF_MHBOXLABEL);
		EAOF_SABoxLabel:SetText(EAOF_SHBOXLABEL);
	else
		EAOF_MABoxLabel:SetText(EAOF_MABOXLABEL);
		EAOF_SABoxLabel:SetText(EAOF_SABOXLABEL);
	end
end

-- Modes Dropdown
function EAOFSO_Modes_DropDown_OnShow()
	UIDropDownMenu_Initialize(EAOFSO_Modes_DropDown, EAOFSO_Modes_DropDown_Initialize);
	UIDropDownMenu_SetWidth(110);
	UIDropDownMenu_SetButtonWidth(54);
	UIDropDownMenu_JustifyText("LEFT", EAOFSO_Modes_DropDown);
end

function EAOFSO_Modes_DropDown_Initialize()
	local info;
	for modeID,title in EA_Modes do
		checked = nil;
		info = {};
		info.text = title;
		info.func = EAOFSO_Modes_DropDown_OnClick;
		if (EnhancedAssistOptions.UserMode == modeID) then checked = 1 end
		info.checked = checked;
		UIDropDownMenu_AddButton(info);
	end
	UIDropDownMenu_SetText(EA_Modes[EnhancedAssistOptions.UserMode], EAOFSO_Modes_DropDown);
	UIDropDownMenu_SetSelectedID(EAOFSO_Modes_DropDown, EnhancedAssistOptions.UserMode);
end

function EAOFSO_Modes_DropDown_OnClick()
	-- DEFAULT_CHAT_FRAME:AddMessage(this:GetID() .. " - " .. this:GetName() );
	UIDropDownMenu_SetSelectedID(EAOFSO_Modes_DropDown, this:GetID());
	EnhancedAssistOptions.UserMode = this:GetID();
	-- Update All the frames that use labels which need updating to reflect the mode change
	EnhancedAssistOptionsFrame_OnShow();
	EnhancedAssist_updateCurrentAssists();
	-- PlaySoundFile(EA_Sounds[EnhancedAssistOptions.Sounds.Assist]);
end

-- Assist Sounds Dropdown
function EAOFSO_SoundAssist_DropDown_OnShow()
	UIDropDownMenu_Initialize(EAOFSO_SoundAssist_DropDown, EAOFSO_SoundAssist_DropDown_Initialize);
	UIDropDownMenu_SetWidth(110);
	UIDropDownMenu_SetButtonWidth(54);
	UIDropDownMenu_JustifyText("LEFT", EAOFSO_SoundAssist_DropDown);
end

function EAOFSO_SoundAssist_DropDown_Initialize()
	local info;
	for title,file in EA_Sounds do
		checked = nil;
		info = {};
		info.text = title;
		info.func = EAOFSO_SoundAssist_DropDown_OnClick;
		if (EnhancedAssistOptions.Sounds.Assist == title) then checked = 1 end
		info.checked = checked;
		UIDropDownMenu_AddButton(info);
	end
	UIDropDownMenu_SetText(EnhancedAssistOptions.Sounds.Assist, EAOFSO_SoundAssist_DropDown);
	UIDropDownMenu_SetSelectedName(EAOFSO_SoundAssist_DropDown, EnhancedAssistOptions.Sounds.Assist);
end

function EAOFSO_SoundAssist_DropDown_OnClick()
	-- DEFAULT_CHAT_FRAME:AddMessage(this:GetID() .. " - " .. this:GetText() );
	UIDropDownMenu_SetSelectedID(EAOFSO_SoundAssist_DropDown, this:GetID());
	EnhancedAssistOptions.Sounds.Assist = this:GetText();
	PlaySoundFile(EA_Sounds[EnhancedAssistOptions.Sounds.Assist]);
end

-- Stop Sounds Dropdown
function EAOFSO_SoundStop_DropDown_OnShow()
	UIDropDownMenu_Initialize(EAOFSO_SoundStop_DropDown, EAOFSO_SoundStop_DropDown_Initialize);
	UIDropDownMenu_SetWidth(110);
	UIDropDownMenu_SetButtonWidth(54);
	UIDropDownMenu_JustifyText("LEFT", EAOFSO_SoundStop_DropDown);
end

function EAOFSO_SoundStop_DropDown_Initialize()
	local info;
	for title,file in EA_Sounds do
		checked = nil;
		info = {};
		info.text = title;
		info.func = EAOFSO_SoundStop_DropDown_OnClick;
		if (EnhancedAssistOptions.Sounds.Stop == title) then checked = 1 end
		info.checked = checked;
		UIDropDownMenu_AddButton(info);
	end
	UIDropDownMenu_SetText(EnhancedAssistOptions.Sounds.Stop, EAOFSO_SoundStop_DropDown);
	UIDropDownMenu_SetSelectedName(EAOFSO_SoundStop_DropDown, EnhancedAssistOptions.Sounds.Stop);
end

function EAOFSO_SoundStop_DropDown_OnClick()
	-- DEFAULT_CHAT_FRAME:AddMessage(this:GetID() .. " - " .. this:GetText() );
	UIDropDownMenu_SetSelectedID(EAOFSO_SoundStop_DropDown, this:GetID());
	EnhancedAssistOptions.Sounds.Stop = this:GetText();
	PlaySoundFile(EA_Sounds[EnhancedAssistOptions.Sounds.Stop]);
end
